#!

;;; File: "pump.scm"

;; start like this:
;;
;;  % xterm -e gsi -:tE pump.scm 9000
;;
;; then
;;
;;  % telnet localhost 9000
;;
;; Tested with Gambit v4.4.4 commit f0c06aecdbe96346a06fcdb62a1f88c9c79514a9 .

(define port-num (string->number (cadr (command-line))))

(define listen-port (open-tcp-server port-num))

(define connection (read listen-port))

(define (copy in out)
  (let* ((buflen 1000)
         (buf (make-u8vector buflen)))
    (let loop ()
      (let ((n (read-subu8vector buf 0 buflen in 1)))
        (if (> n 0)
            (begin
              (write-subu8vector buf 0 n out)
              (force-output out)
              (loop)))))))

(let ((in (repl-input-port))
      (out (repl-output-port)))

  #;
  (if (tty? in)
      (tty-mode-set! in #f #t #f #f 38400)) ;; disallow ^C

  (thread-start!
   (make-thread
    (lambda ()
      (copy connection out)
      (exit 0)))) ;; when the pump process exits, the xterm will terminate too

  (copy in connection))
